// Copyright 2003 Adam Megacz, see the COPYING file for licensing [GPL]
package org.xwt.util;

/** Simple implementation of a blocking, counting semaphore. */
public class Semaphore {
    
    private int val = 0;

    public Semaphore() { };

    /** Decrement the counter, blocking if zero. */
    public synchronized void block() {
        while(val == 0) {
            try {
                wait();
            } catch (InterruptedException e) {
            } catch (Throwable e) {
                if (Log.on) Log.log(this, "Exception in Semaphore.block(); this should never happen");
                if (Log.on) Log.log(this, e);
            }
        }
        val--;
    }
    
    /** Incremenet the counter. */
    public synchronized void release() {
        val++;
        notify();
    }

}
